--- libcpp/init.c.jj	2021-11-17 20:08:18.359724792 +0100
+++ libcpp/init.c	2021-11-29 11:40:05.989432952 +0100
@@ -114,14 +114,14 @@ static const struct lang_flags lang_defa
   /* STDC2X   */  { 1,  0,  1,  1,  1,  0,    1,  1,   1,   0,   0,    1,     1,     1,   1,      0,   1,     1,   0,   1 },
   /* GNUCXX   */  { 0,  1,  1,  1,  0,  0,    0,  1,   0,   0,   0,    0,     0,     0,   0,      1,   1,     0,   0,   0 },
   /* CXX98    */  { 0,  1,  0,  1,  0,  0,    1,  1,   0,   0,   0,    0,     0,     1,   0,      0,   1,     0,   0,   0 },
-  /* GNUCXX11 */  { 1,  1,  1,  1,  1,  0,    0,  1,   1,   1,   1,    0,     0,     0,   0,      1,   1,     0,   0,   0 },
-  /* CXX11    */  { 1,  1,  0,  1,  1,  0,    1,  1,   1,   1,   1,    0,     0,     1,   0,      0,   1,     0,   0,   0 },
-  /* GNUCXX14 */  { 1,  1,  1,  1,  1,  0,    0,  1,   1,   1,   1,    1,     1,     0,   0,      1,   1,     0,   0,   0 },
-  /* CXX14    */  { 1,  1,  0,  1,  1,  0,    1,  1,   1,   1,   1,    1,     1,     1,   0,      0,   1,     0,   0,   0 },
-  /* GNUCXX17 */  { 1,  1,  1,  1,  1,  0,    0,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   0,   0 },
-  /* CXX17    */  { 1,  1,  1,  1,  1,  0,    1,  1,   1,   1,   1,    1,     1,     0,   1,      0,   1,     0,   0,   0 },
-  /* GNUCXX20 */  { 1,  1,  1,  1,  1,  0,    0,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   0,   0 },
-  /* CXX20    */  { 1,  1,  1,  1,  1,  0,    1,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   0,   0 },
+  /* GNUCXX11 */  { 1,  1,  1,  1,  1,  1,    0,  1,   1,   1,   1,    0,     0,     0,   0,      1,   1,     0,   0,   0 },
+  /* CXX11    */  { 1,  1,  0,  1,  1,  1,    1,  1,   1,   1,   1,    0,     0,     1,   0,      0,   1,     0,   0,   0 },
+  /* GNUCXX14 */  { 1,  1,  1,  1,  1,  1,    0,  1,   1,   1,   1,    1,     1,     0,   0,      1,   1,     0,   0,   0 },
+  /* CXX14    */  { 1,  1,  0,  1,  1,  1,    1,  1,   1,   1,   1,    1,     1,     1,   0,      0,   1,     0,   0,   0 },
+  /* GNUCXX17 */  { 1,  1,  1,  1,  1,  1,    0,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   0,   0 },
+  /* CXX17    */  { 1,  1,  1,  1,  1,  1,    1,  1,   1,   1,   1,    1,     1,     0,   1,      0,   1,     0,   0,   0 },
+  /* GNUCXX20 */  { 1,  1,  1,  1,  1,  1,    0,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   0,   0 },
+  /* CXX20    */  { 1,  1,  1,  1,  1,  1,    1,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   0,   0 },
   /* GNUCXX23 */  { 1,  1,  1,  1,  1,  1,    0,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   1,   1 },
   /* CXX23    */  { 1,  1,  1,  1,  1,  1,    1,  1,   1,   1,   1,    1,     1,     0,   1,      1,   1,     0,   1,   1 },
   /* ASM      */  { 0,  0,  1,  0,  0,  0,    0,  0,   0,   0,   0,    0,     0,     0,   0,      0,   0,     0,   0,   0 }
--- gcc/testsuite/c-c++-common/cpp/ucnid-2011-1-utf8.c.jj	2020-01-14 20:02:46.649611841 +0100
+++ gcc/testsuite/c-c++-common/cpp/ucnid-2011-1-utf8.c	2021-11-29 12:11:51.640324720 +0100
@@ -2,7 +2,7 @@
 /* { dg-options "-std=c11 -pedantic" { target c } } */
 /* { dg-options "-std=c++11 -pedantic" { target c++ } } */
 
-¨
+¨ /* { dg-error "is not valid in an identifier" "" { target c++ } } */
 
 B̀
 
@@ -11,5 +11,5 @@ B̀
 À /* { dg-warning "not in NFC" } */
 
 ?
-?
-?
+?	/* { dg-error "is not valid in an identifier" "" { target c++ } } */
+?	/* { dg-error "is not valid in an identifier" "" { target c++ } } */
--- gcc/testsuite/c-c++-common/cpp/ucnid-2011-1.c.jj	2020-01-14 20:02:46.649611841 +0100
+++ gcc/testsuite/c-c++-common/cpp/ucnid-2011-1.c	2021-11-29 12:12:02.230174227 +0100
@@ -2,7 +2,7 @@
 /* { dg-options "-std=c11 -pedantic" { target c } } */
 /* { dg-options "-std=c++11 -pedantic" { target c++ } } */
 
-\u00A8
+\u00A8 /* { dg-error "is not valid in an identifier" "" { target c++ } } */
 
 B\u0300
 
@@ -11,5 +11,5 @@ B\u0300
 A\u0300 /* { dg-warning "not in NFC" } */
 
 \U00010000
-\U0001FFFD
-\U000E1234
+\U0001FFFD	/* { dg-error "is not valid in an identifier" "" { target c++ } } */
+\U000E1234	/* { dg-error "is not valid in an identifier" "" { target c++ } } */
--- gcc/testsuite/g++.dg/cpp/ucnid-4-utf8.C.jj	2020-01-14 20:02:46.702611047 +0100
+++ gcc/testsuite/g++.dg/cpp/ucnid-4-utf8.C	2021-11-29 12:09:44.871126209 +0100
@@ -1,5 +1,5 @@
 /* { dg-do preprocess } */
-/* { dg-options "-std=gnu++98"} */
+/* { dg-options "-std=gnu++98" } */
 
 ª
 « /* { dg-error "not valid in an identifier" } */
--- gcc/testsuite/g++.dg/cpp23/normalize3.C.jj	2021-09-01 22:32:39.624869716 +0200
+++ gcc/testsuite/g++.dg/cpp23/normalize3.C	2021-11-29 11:42:49.283104059 +0100
@@ -1,4 +1,4 @@
-// { dg-do preprocess { target { c++23 } } }
+// { dg-do preprocess { target { c++11 } } }
 // { dg-options "-pedantic-errors" }
 
 \u00AA
--- gcc/testsuite/g++.dg/cpp23/normalize4.C.jj	2021-09-01 22:32:39.624869716 +0200
+++ gcc/testsuite/g++.dg/cpp23/normalize4.C	2021-11-29 11:43:03.542900685 +0100
@@ -1,4 +1,4 @@
-// { dg-do preprocess { target { c++23 } } }
+// { dg-do preprocess { target { c++11 } } }
 // { dg-options "" }
 
 \u00AA
--- gcc/testsuite/g++.dg/cpp23/normalize5.C.jj	2021-09-01 22:32:39.624869716 +0200
+++ gcc/testsuite/g++.dg/cpp23/normalize5.C	2021-11-29 11:43:14.662742096 +0100
@@ -1,4 +1,4 @@
-// { dg-do preprocess { target { c++23 } } }
+// { dg-do preprocess { target { c++11 } } }
 // { dg-options "-pedantic-errors" }
 
 \u00AA
--- gcc/testsuite/g++.dg/cpp23/normalize7.C.jj	2021-09-01 22:32:39.624869716 +0200
+++ gcc/testsuite/g++.dg/cpp23/normalize7.C	2021-11-29 11:51:00.691111036 +0100
@@ -3,10 +3,8 @@
 // { dg-options "-pedantic-errors" }
 
 constexpr int À = 1; // U+00C0
-constexpr int À = 2; // U+0041 U+0300 { dg-warning "is not in NFC" "" { target { ! c++23 } } }
-// { dg-error "is not in NFC" "" { target c++23 } .-1 }
+constexpr int À = 2; // U+0041 U+0300 { dg-error "is not in NFC" }
 constexpr int gv1 = \u00c0;
-constexpr int gv2 = A\u0300; // { dg-warning "is not in NFC" "" { target { ! c++23 } } }
-// { dg-error "is not in NFC" "" { target c++23 } .-1 }
+constexpr int gv2 = A\u0300; // { dg-error "is not in NFC" }
 static_assert(gv1 == 1, "");
 static_assert(gv2 == 2, "");
--- gcc/testsuite/g++.dg/cpp23/ucnid-2-utf8.C.jj	2021-09-01 22:32:39.624869716 +0200
+++ gcc/testsuite/g++.dg/cpp23/ucnid-2-utf8.C	2021-11-29 11:44:49.803387527 +0100
@@ -2,17 +2,17 @@
 // { dg-do compile }
 // { dg-options "-pedantic-errors" }
 
-bool ? = true;	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+bool ? = true;	// { dg-error "is not valid in an identifier" }
 bool ?‍♀ = false;	// { dg-error "is not valid in an identifier" }
 int ⏰ = 0;	// { dg-error "is not valid in an identifier" }
-int ? = 0;	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+int ? = 0;	// { dg-error "is not valid in an identifier" }
 int ☠ = 0;	// { dg-error "is not valid in an identifier" }
-int ? = 0;	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+int ? = 0;	// { dg-error "is not valid in an identifier" }
 int ✋ = 0;	// { dg-error "is not valid in an identifier" }
-int ? = 0;	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+int ? = 0;	// { dg-error "is not valid in an identifier" }
 int ✈ = 0;	// { dg-error "is not valid in an identifier" }
-int ? = 0;	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+int ? = 0;	// { dg-error "is not valid in an identifier" }
 int ☹ = 0;	// { dg-error "is not valid in an identifier" }
-int ? = 0;	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+int ? = 0;	// { dg-error "is not valid in an identifier" }
 struct E {};
-class ? : public E {};	// { dg-error "is not valid in an identifier" "" { target { c++98_only || c++23 } } }
+class ? : public E {};	// { dg-error "is not valid in an identifier" }